# Options for analysis running.
run:
  # See the dedicated "run" documentation section.
  timeout: 10m

# output configuration options
output:
  # See the dedicated "output" documentation section.
  sort-results: true

# All available settings of specific linters.
linters-settings:
  gocognit:
    # Minimal code complexity to report.
    min-complexity: 15
  goconst:
    # Minimal length of string constant.
    min-len: 2
    # Minimum occurrences of constant string count to trigger issue.
    min-occurrences: 2
  misspell:
    locale: US
  lll:
    # Minimal code complexity to report.
    line-length: 140
  gocritic:
    enabled-tags:
      - diagnostic
      - experimental
      - opinionated
      - performance
      - style
    disabled-checks:
      - wrapperFunc
      - dupImport
      - ifElseChain
      - octalLiteral
      - sloppyReassign
      - unnamedResult
  funlen:
    lines: 100
    statements: 50
  govet:
    check-shadowing: false
  varnamelen:
    ignore-names:
      - db
      - tx
    ignore-decls:
      - id uuid.UUID
      - w http.ResponseWriter
      - r *http.Request
      - r *chi.Mux
      - r chi.Router
      - md *meta.Data
linters:
  # please, do not use `enable-all`: it's deprecated and will be removed soon.
  # inverted configuration with `enable-all` and `disable` is not scalable during updates of golangci-lint
  disable-all: true
  enable:
    - errcheck
    - gosimple
    - govet
    - ineffassign
    - staticcheck
    - typecheck
    - unused
    - asasalint
    - asciicheck
    - bidichk
    - bodyclose
    - contextcheck
    - decorder
    - dogsled
    - dupl
    - durationcheck
    - errchkjson
    - errname
    - errorlint
    - execinquery
    - exhaustive
    - exportloopref
    - forcetypeassert
    - funlen
    - gci
    - gochecknoglobals
    - gochecknoinits
    - gocognit
    - goconst
    - gocritic
    - godot
    - goerr113
    - gofmt
    - gofumpt # stricter gofmt
    - goimports
    - gomnd
    - goprintffuncname
    - gosec
    - grouper
    - importas
    - interfacebloat
    - ireturn
    - lll
    - loggercheck
    - maintidx
    - makezero
    - misspell
    - nakedret
    - nestif
    - nilerr
    - nilnil
    - noctx
    - nolintlint
    - nonamedreturns
    - nosprintfhostport
    - paralleltest
    - prealloc
    - predeclared
    - promlinter
    - reassign
    - revive
    - rowserrcheck
    - sqlclosecheck
    - stylecheck
    - tagliatelle
    - tenv
    - testableexamples
    - testpackage
    - thelper
    - tparallel
    - unconvert
    - unparam
    - usestdlibvars
    - varnamelen
    - wastedassign
    - whitespace
    - wrapcheck
    - wsl
  # don't enable:
  # - gocyclo
  # - godox
issues:
  # See the dedicated "issues" documentation section.
  option: value
severity:
  # See the dedicated "severity" documentation section.
  option: value
